/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: mc.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ޥ⥸塼
 */
#include "kernel_impl.h"
#include "mc.h"
#include "target_ici.h"
#include "task.h"
#include "interrupt.h"
#include "check.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_SHUTALLCORE_ENTER
#define LOG_SHUTALLCORE_ENTER(ercd)
#endif /* LOG_SHUTALLCORE_ENTER */

#ifndef LOG_SHUTALLCORE_LEAVE
#define LOG_SHUTALLCORE_LEAVE()
#endif /* LOG_SHUTALLCORE_LEAVE */


#ifdef TOPPERS_ccb_initialize


#if TTYPE_KLOCK == G_KLOCK

/*
 *  㥤ȥå
 */
LockType			giant_lock;

#else /* TTYPE_KLOCK == G_KLOCK */

/*
 *  ԥåå
 */
LockType			spn_lock;

/*
 *  IOCå
 */
LockType			ioc_lock;

#endif /* TTYPE_KLOCK == G_KLOCK */

#ifndef OMIT_KER_REQ_ON_ICI
/*
 *  λ׵ե饰
 */
volatile boolean	shutdown_reqflg;
#endif /* OMIT_KER_REQ_ON_ICI */

/*
 *  ưƤOSΥ
 *  ޥɬưΤ1ǽ
 */
uint32				activated_cores = 1U;

/*
 *  ޥ⥸塼ν
 */
void
ccb_initialize(void)
{
	uint32		i;
	CCB			*my_p_ccb = get_my_p_ccb();
	CoreIdType	coreid = x_core_id();

	/*
	 *  CCB coreid 
	 */
	my_p_ccb->coreid = coreid;

#if TTYPE_KLOCK == G_KLOCK
	/*
	 *  㥤ȥåν
	 */
	x_initialize_giant_lock(&giant_lock);
#else /* TTYPE_KLOCK != G_KLOCK */
	/*
	 *  åν
	 */
	x_initialize_tsk_lock(&(my_p_ccb->tsk_lock));

	/*
	 *  󥿥åν
	 */
	x_initialize_cnt_lock(&(my_p_ccb->cnt_lock));

	if (x_sense_mcore() != FALSE) {
		/*
		 *  ԥååν
		 */
		x_initialize_spn_lock(&spn_lock);

		/*
		 *  IOCåν
		 */
		x_initialize_ioc_lock(&ioc_lock);
	}

#endif /* TTYPE_KLOCK == C_KLOCK */

	/*
	 *  طν
	 */
	my_p_ccb->p_runtsk = my_p_ccb->p_schedtsk = NULL;
	my_p_ccb->nextpri = TPRI_MINTASK;

	for (i = 0U; i < TNUM_TPRI; i++) {
		queue_initialize(&(my_p_ccb->ready_queue[i]));
	}

	my_p_ccb->ready_primap = 0U;

	/*
	 *  ߴطν
	 */
	my_p_ccb->p_runisr = NULL;

	my_p_ccb->sus_all_cnt = 0U;
	my_p_ccb->sus_all_cnt_ctx = 0U;
	my_p_ccb->wrap_sus_all_cnt = 0U;
	my_p_ccb->sus_os_cnt = 0U;
	my_p_ccb->sus_os_cnt_ctx = 0U;
	my_p_ccb->wrap_sus_os_cnt = 0U;

#ifndef OMIT_KER_REQ_ON_ICI
	if (x_sense_mcore() != FALSE) {
		shutdown_reqflg = FALSE;
	}
#endif /*  OMIT_KER_REQ_ON_ICI */

	/*
	 *  桼ֳ׵ν
	 */
	my_p_ccb->ici_request_map = 0U;

	/*
	 *  ǥѥåѥֳ׵ե饰ν
	 */
	my_p_ccb->ici_disreqflg = FALSE;

	/*
	 *  OSץꥱطν
	 */
	my_p_ccb->p_runosap = NULL;

	/*
	 *  ץƥեåѥԥåطν
	 */
	my_p_ccb->p_protectspncb = NULL;
}

#endif /* TOPPERS_ccb_initialize */

/*
 *  ֳߥϥɥ
 */
#ifdef TOPPERS_ici_handler_main

#ifdef CFG_USE_STACKMONITORING
/*
 *  ICISR˼»ܤ륹å˥󥰽
 */
LOCAL_INLINE void
ici_stk_monitoring(void)
{
	StackType *ostk_top;

	ostk_top = _ostk_table[x_core_id()];
	if (ostk_top[0] != STACK_MAGIC_NUMBER) {
		stack_monitoring_error_isr();
	}
}
#endif /* CFG_USE_STACKMONITORING */

void
ici_handler_main(void)
{
	CCB				*my_p_ccb;
	uint32			reqmap;
	uint16			reqmap_half;
	uint32			icino;
	ISRCB			*p_runisr_saved;
	const OSAPINIB	*p_runosap_saved;

	my_p_ccb = get_my_p_ccb();

	target_ici_clear();

#ifndef OMIT_KER_REQ_ON_ICI
	/*
	 *  λ׵å
	 */
	if (shutdown_reqflg != FALSE) {
		internal_shutdownallcores(E_OS_SHUTDOWN_OTHER_CORE);
	}
#endif /* OMIT_KER_REQ_ON_ICI */

	x_nested_lock_os_int();
	acquire_tsk_lock(my_p_ccb);

	reqmap = my_p_ccb->ici_request_map;
	while (reqmap != 0U) {
		/* ֳߤװ򸡺(ǲ̥ӥåͥ) */
		reqmap_half = (uint16) (reqmap & 0x0000ffffU);
		if (reqmap_half != 0U) {
			icino = (uint32) bitmap_search(reqmap_half);
		}
		else {
			reqmap_half = (uint16) ((reqmap & 0xffff0000U) >> 16U);
			icino = (uint32) bitmap_search(reqmap_half) + 16U;
		}
		/* õ줿װ׵ӥåȤȤ */
		my_p_ccb->ici_request_map &= ~(0x00000001U << icino);

		if (icino < tnum_ici_of_core[my_p_ccb->coreid]) {
			/*
			 *  桼װä硤ICISRϥɥθƤӽФ
			 *  ICISRϥɥ¹ˤICISRν°OSAPp_runosapꤹ
			 */
			p_runisr_saved = my_p_ccb->p_runisr;
			my_p_ccb->p_runisr = get_isrcb(((p_iciinb_table[my_p_ccb->coreid])[icino]).iciid);
			p_runosap_saved = my_p_ccb->p_runosap;
			my_p_ccb->p_runosap = my_p_ccb->p_runisr->p_isrinib->p_osapinib;
			release_tsk_lock(my_p_ccb);
			x_nested_unlock_os_int();

			(((p_iciinb_table[my_p_ccb->coreid])[icino]).ici_routing)();

#ifdef CFG_USE_STACKMONITORING
			/* ICISR˥å˥󥰤» */
			ici_stk_monitoring();
#endif /* CFG_USE_STACKMONITORING */

			/* ICISRλå */
			exit_isr2();

			x_nested_lock_os_int();
			acquire_tsk_lock(my_p_ccb);
			my_p_ccb->p_runosap = p_runosap_saved;
			my_p_ccb->p_runisr = p_runisr_saved;
		}
		else {
			/*
			 *  桼ʳICISRξ
			 *  뤳Ȥʤ
			 */
		}
		reqmap = my_p_ccb->ici_request_map;
	}

	/*
	 *  ǥѥåѥֳ׵ե饰򥯥ꥢ
	 */
	my_p_ccb->ici_disreqflg = FALSE;

	release_tsk_lock(my_p_ccb);
	x_nested_unlock_os_int();
}

#endif /* TOPPERS_ici_handler_main */

/*
 *  ǥѥå׵
 *  оݤ¾ξϥֳߤȯԤ
 *
 *   å˸ƤӽФ뤳ȤȤ롥
 */
#ifdef TOPPERS_dispatch_request

boolean
dispatch_request(CCB *p_ccb)
{
	CCB *my_p_ccb;

	my_p_ccb = get_my_p_ccb();

	if (p_ccb == my_p_ccb) {
		return(TRUE);
	}
	else {
		/* ǥѥåֳȯԤ硤ȯԤʤ */
		if (p_ccb->ici_disreqflg == FALSE) {
			p_ccb->ici_disreqflg = TRUE;
			target_ici_dispreq(p_ccb);
		}
		return(FALSE);
	}
}

#endif /* TOPPERS_dispatch_request */

#ifndef OMIT_KER_REQ_ON_ICI
#ifdef TOPPERS_shutdown_request

/*
 *  λ׵
 */
void
shutdown_request(void)
{
	CoreIdType	coreid;
	CoreIdType	my_coreid = x_core_id();
	CCB			*p_ccb;

	/* Ǥ׵᤬ФƤХ꥿ */
	if (shutdown_reqflg == FALSE) {
		shutdown_reqflg = TRUE;
		for (coreid = 0U; coreid < TotalNumberOfCores; coreid++) {
			p_ccb = get_p_ccb(coreid);
			if ((p_ccb->kerflg != FALSE) && (coreid != my_coreid)) {
				target_ici_raise(coreid);
			}
		}
	}
}

#endif /* TOPPERS_shutdown_request */
#endif /* OMIT_KER_REQ_ON_ICI */

#ifndef OMIT_BARRIER_SYNC
#ifdef TOPPERS_barrier_sync

#ifndef TNUM_BUSY_LOOP
#define TNUM_BUSY_LOOP	100U
#endif /* TNUM_BUSY_LOOP */

/*
 *  ХꥢƱѤԤ
 */
LOCAL_INLINE void
busy_wait(void)
{
	volatile uint8 i;
	for (i = 0U; i < TNUM_BUSY_LOOP; i++) {
	}
}

/*
 *  ХꥢƱ
 */
void
barrier_sync(uint8 phase, boolean check_shutdown)
{
	CoreIdType				i;
	CoreIdType				flag;
	static volatile uint8	sys_start;
	static volatile uint8	core_init[TotalNumberOfCores] = {
		0U
	};

	core_init[x_core_id()] = phase;

	if (x_sense_mcore() != FALSE) {
		do {
			flag = 0U;
			for (i = 0U; i < TotalNumberOfCores; i++) {
				if (core_init[i] == phase) {
					flag++;
				}
			}
			busy_wait();
			if ((check_shutdown != FALSE) && (shutdown_reqflg != FALSE)) {
				/*
				 *  internal_shutdownallcoresƤOS߶ػ߾֤
				 *  ߶ػ߾ֲ
				 */
				x_nested_lock_os_int();
				x_unlock_all_int();
				internal_shutdownallcores(E_OS_SHUTDOWN_OTHER_CORE);
			}
		} while (flag < activated_cores);
		sys_start = phase;
	}
	else {
		while (sys_start != phase) {
			busy_wait();
			if ((check_shutdown != FALSE) && (shutdown_reqflg != FALSE)) {
				/*
				 *  internal_shutdownallcoresƤOS߶ػ߾֤
				 *  ߶ػ߾ֲ
				 */
				x_nested_lock_os_int();
				x_unlock_all_int();
				internal_shutdownallcores(E_OS_SHUTDOWN_OTHER_CORE);
			}
		}
	}
}

#endif /* TOPPERS_barrier_sync */
#endif /* OMIT_BARRIER_SYNC */

/*
 *  OSShutdownAllCoresθƤӽФ
 */
#ifdef TOPPERS_internal_shutdownallcores

void
internal_shutdownallcores(StatusType ercd)
{
	LOG_SHUTALLCORE_ENTER(ercd);
	x_nested_lock_os_int();

	shutdown_request();

#ifdef CFG_USE_SHUTDOWNHOOK
	call_shutdownhook(ercd);
#endif /* CFG_USE_SHUTDOWNHOOK */

	/* ƥ⥸塼νλ */
	object_terminate();

	x_lock_all_int();
	LOG_SHUTALLCORE_LEAVE();

	/* åȰ¸νλ */
	target_exit();

	/*
	 * åȰ¸֤äƤ硤
	 * ̵¥롼פԤ
	 */
	while (1) {
	}

}

#endif /* TOPPERS_internal_shutdownallcores */


#if TTYPE_KLOCK != G_KLOCK
/*
 *  åΥåؿ
 */
/*
 *		ƥѤΥåؿ
 */

/*
 *  ǤեʼޤˤΥåμǤդΥƥ/1ܡ
 */
#ifdef TOPPERS_acquire_tsk_lock

void
acquire_tsk_lock(CCB *p_ccb)
{
	x_acquire_lock(&(p_ccb->tsk_lock));
}

#endif /* TOPPERS_acquire_tsk_lock */

/*
 *  åβǤդΥƥȡ
 */
#ifdef TOPPERS_release_tsk_lock

void
release_tsk_lock(CCB *p_ccb)
{
	x_release_lock(&(p_ccb->tsk_lock));
}

#endif /* TOPPERS_release_tsk_lock */

/*
 *  åβȥǥѥå
 */
#ifdef TOPPERS_release_tsk_lock_and_dispatch

void
release_tsk_lock_and_dispatch(CCB *p_ccb,  boolean dspreq)
{
	x_release_lock(&(p_ccb->tsk_lock));
	if (dspreq) {
		dispatch();
	}
}

#endif /* TOPPERS_release_tsk_lock_and_dispatch */

/*
 *  󥿥åμǤդΥƥȡ
 */
#ifdef TOPPERS_acquire_cnt_lock

void
acquire_cnt_lock(CCB *p_ccb)
{
	x_acquire_lock(&(p_ccb->cnt_lock));
}

#endif /* TOPPERS_acquire_cnt_lock */

/*
 * 󥿥åβǤդΥƥȡ
 */
#ifdef TOPPERS_release_cnt_lock

void
release_cnt_lock(CCB *p_ccb)
{
	x_release_lock(&(p_ccb->cnt_lock));
}

#endif /* TOPPERS_release_cnt_lock */

/*
 *	ԥåμǤդΥƥȡ
 */
#ifdef TOPPERS_acquire_spn_lock

void
acquire_spn_lock(LockType *p_spnlock)
{
	x_acquire_lock(p_spnlock);
}

#endif /* TOPPERS_acquire_spn_lock */

/*
 *	ԥåβǤդΥƥȡ
 */
#ifdef TOPPERS_release_spn_lock

void
release_spn_lock(LockType *p_spnlock)
{
	x_release_lock(p_spnlock);
}

#endif /* TOPPERS_release_spn_lock */

/*
 *	ԥåμԡǤդΥƥȡ
 */
#ifdef TOPPERS_try_spn_lock

boolean
try_spn_lock(LockType *p_spnlock)
{
	return(x_try_lock(p_spnlock));
}

#endif /* TOPPERS_try_spn_lock */

/*
 *  IOCåμǤդΥƥȡ
 */
#ifdef TOPPERS_acquire_ioc_lock
void
acquire_ioc_lock(LockType *p_ioclock)
{
	x_acquire_lock(p_ioclock);
}

#endif /* TOPPERS_acquire_ioc_lock */

/*
 *	IOCåβǤդΥƥȡ
 */
#ifdef TOPPERS_release_ioc_lock
void
release_ioc_lock(LockType *p_ioclock)
{
	x_release_lock(p_ioclock);
}

#endif /* TOPPERS_release_ioc_lock */

#endif /* TTYPE_KLOCK != G_KLOCK */
