/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: spinlock.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ԥåǽ
 */

#ifndef TOPPERS_SPINLOCK_H
#define TOPPERS_SPINLOCK_H

/*
 *  ԥåID饹ԥå֥åФΥޥ
 *   ԥåID1ꥸʤΤ-1
 */
#define get_spncb(spnid)	(&(spncb_table[(spnid) - 1U]))

/*
 *  ԥåID饹ԥå֥åФΥޥ
 *   ԥåID1ꥸʤΤ-1
 */
#define get_spninib(spnid)	(&(spninib_table[(spnid) - 1U]))

/*
 *  ԥå֥å
 */
typedef struct spinlock_initialization_block {
	StatusType (*susint)(void);                                 /* ߶ػߴؿ(option) */
	FunctionRefType								resint;         /* ߵĴؿ(option) */
	const struct spinlock_initialization_block	*p_nextspn;     /* ˼륹ԥå */
} SPNINIB;

/*
 *  ԥå֥å
 */
typedef struct spinlock_control_block {
	const SPNINIB					*p_spninib;     /* ֥åؤΥݥ */
	CCB								*p_ccb;         /* åƤ륳 */
	void							*p_holdcb;      /* åƤ륿C2ISRޤϥץƥեå */
	struct spinlock_control_block	*p_prevspncb;   /* ˳ԥå */
} SPNCB;

/*
 *  ԥå֥åΥꥢOs_Lcfg.c
 */
extern const SPNINIB		spninib_table[];

/*
 *  ԥå֥åΥꥢOs_Lcfg.c
 */
extern SPNCB				spncb_table[];

/*
 *  ԥåǽν
 */
extern void spinlock_initialize(void);

/*
 *  ԥåݻѿOs_Lcfg.c
 */
extern const SpinlockIdType	tnum_spinlock;  /* ԥåο */

/*
 *  ԥååԥ󥰤߶ػ
 */
extern StatusType wrap_sus_all_int(void);

/*
 *  ԥååԥ󥰤߶ػ߲
 */
extern void wrap_res_all_int(void);

/*
 *  ԥååԥ󥰤OS߶ػ
 */
extern StatusType wrap_sus_os_int(void);

/*
 *  ԥååԥ󥰤OS߶ػ߲
 */
extern void wrap_res_os_int(void);

#endif /* TOPPERS_SPINLOCK_H */
