/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: strerror.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		顼åʸ֤ؿ
 */

#include "Os.h"
#include "t_stdlib.h"
#include "Ioc.h"


const char8 *
atk2_strerror(StatusType ercd)
{
	/* 顼ʸơ֥	*/
	static const char8	*ercd_tbl[] = {
		"E_OK",
		"E_OS_ACCESS",
		"E_OS_CALLEVEL",
		"E_OS_ID",
		"E_OS_LIMIT",
		"E_OS_NOFUNC",
		"E_OS_RESOURCE",
		"E_OS_STATE",
		"E_OS_VALUE",
		"E_OS_SERVICEID",
		"E_OS_ILLEGAL_ADDRESS",
		"E_OS_MISSINGEND",
		"E_OS_DISABLEDINT",
		"E_OS_STACKFAULT",
		"E_OS_PROTECTION_MEMORY",
		"E_OS_PROTECTION_TIME_TASK",
		"E_OS_PROTECTION_TIME_ISR",
		"E_OS_PROTECTION_ARRIVAL_TASK",
		"E_OS_PROTECTION_ARRIVAL_ISR",
		"E_OS_PROTECTION_LOCKED_RESOURCE",
		"E_OS_PROTECTION_LOCKED_OSINT",
		"E_OS_PROTECTION_LOCKED_ALLINT",
		"E_OS_PROTECTION_EXCEPTION",
		"E_OS_PROTECTION_FATAL",
		"E_OS_MODE",
		"E_OS_SHUTDOWN_FATAL",
		"E_OS_PARAM_POINTER",
		"E_OS_SYS_ASSERT_FATAL",
		"E_OS_CORE",
		"E_OS_SPINLOCK",
		"E_OS_INTERFERENCE_DEADLOCK",
		"E_OS_NESTING_DEADLOCK",
		"E_OS_SHUTDOWN_OTHER_CORE",
		"unknown error"
	};

	StatusType			error;

	if (ercd > (StatusType) ERRCODE_NUM) {
		error = (StatusType) (ERRCODE_NUM + 1U);
	}
	else {
		error = ercd;
	}
	return(ercd_tbl[error]);
}


const char8 *
atk2_ioc_strerror(StatusType ercd)
{
	char8 *str;

	switch (ercd) {
	case IOC_E_OK:
		str = "IOC_E_OK";
		break;

	case IOC_E_NOK:
		str = "IOC_E_NOK";
		break;

	case IOC_E_LIMIT:
		str = "IOC_E_LIMIT";
		break;

	case IOC_E_LOST_DATA:
		str = "IOC_E_LOST_DATA";
		break;

	case IOC_E_NO_DATA:
		str = "IOC_E_NO_DATA";
		break;

	default:
		str = "unknown error";
		break;
	}

	return(str);
}
